/*
	$Date: 1996/11/02 18:54:59 $
	$Revision: 1.3 $
*/
#include <stdio.h>
#include "pobox.h"
#include "cand.h"
#include "keys.h"
#include "search.h"
#include "kana.h"
#include "phrase.h"

#define YES 1
#define NO 0

unsigned char hstr[100];	/* $BF~NO$5$l$?L$3NDjJ?2>L>J8;zNs(B */
unsigned char outstr[10000];	/* $B3NDjJ8;zNs(B */

Key candkey[MAXCANDKEYS];	/* $B8tJdI=<((B */
int ncands;	/* $BI=<(8tJd?t(B */

static int candpos[MAXCANDLINES];
static int candposx, candposy;

void erasecand()
{
	int i;
	ncands = 0;
	for(i=0;i<MAXCANDLINES;i++)
		candpos[i] = 0;
}

makecand(CandType candtype, int posx, int posy)
/*
	$BL$3NJ?2>L>DjJ8;zNs(B h $B$+$i8tJdJ8;zNs$N=89g$r7W;;$7$FI=<((B
*/
{
	int i,j,k;
	int x,y;
	int full;

	int hlen;	/* $BL$3NDjJ8;zNsD9(B */
	int olen;	/* $B3NDjJ8;zNsD9(B */
	int plen;	/* $B%W%l%U%#%/%9D9(B */

	unsigned char pat[100];

	hlen = strlen(hstr);
	olen = strlen(outstr);
/* printf("makecand(%d,%d,%d)\n",candtype,posx,posy); */

	erasecand();

	candposx = posx;
	candposy = posy;

	if(strlen(hstr) > 0){
		unsigned char *s = (unsigned char*)strdup(hstr);
		addcand(s,s,candtype);
/*		addcand(htok(s),s,candtype); */
	}

	sprintf(pat,"%s ",hstr);
	makepat(pat,0); /* $B[#Kf8!:w$NI=$r:n@.(B */

	full = NO;
	for(i=nphrases-1;i>=0;i--){
		/*
			$B3NDjJ8;zNs(B(outstr)$B$N:G8eHx$,(Bprefix[i]$B$K%^%C%A$7$+$D(B
			$BFI$_$N@hF,$,L$3NDjJ8;zNs$K0lCW$9$k$b$N$r8tJd$H$9$k(B
		*/
		plen = strlen(pprefix[i]);
		if(olen-plen >= 0 && strcmp(outstr+olen-plen,pprefix[i])==0 &&
			match(pcandyomi[i])){
			if(! addcand(pcand[i],pcandyomi[i],candtype)){
				full = YES;
				break;
			}
		}
	}
	for(i=nwords-1;! full && i>=0;i--){
		/*
			$BFI$_$N@hF,$,L$3NDjJ8;zNs$K0lCW$9$kC18l$r8tJd$H$9$k(B
		*/
		if(match(wcandyomi[i])){
			if(! addcand(wcand[i],wcandyomi[i],candtype)){
				full = YES;
			}
		}
	}
	if(! full){
		unsigned char buf[4];
		unsigned char *s;
		int mismatch;

		s = hstr;
		pat[0] = '\0';
		while(*s){
			if(*s >= 0x80){
				buf[0] = *s++;
				buf[1] = *s++;
				buf[2] = ' ';
				buf[3] = '\0';
			}
			else {
				buf[0] = *s++;
				buf[1] = ' ';
				buf[2] = '\0';
			}
			strcat(pat,buf);
/* printf("pat = <%s>\n",pat); */
		}
		for(mismatch=0; mismatch<3 && !full;mismatch++){
			makepat(pat,mismatch);
			for(i=nwords-1;i>=0;i--){
				/*
					$BFI$_$N@hF,$,L$3NDjJ8;zNs$K0lCW$9$kC18l$r8tJd$H$9$k(B
				*/
				if(match(wcandyomi[i])){
					if(! addcand(wcand[i],wcandyomi[i],candtype)){
						full = YES;
						break;
					}
				}
			}
		}
	}
}

addcand(unsigned char *cstr, unsigned char *ystr, CandType candtype)
{
	int i,j;
	int hlen;
	int lines,otherlines;
	int width;
	int keywidth;

/* printf("addcand(%s,%s,%d)\n",cstr,ystr,candtype); */
	if(ncands >= MAXCANDKEYS) return 0;

	hlen = strlen(hstr);

	/* $B4{$K$=$N8tJd$,8tJd%j%9%H$K$"$l$P%9%-%C%W(B */
	for(i=0;i<ncands;i++){
		if(strcmp(cstr,candkey[i].str) == 0){
			return 1;
		}
	}
	if(candtype == MENU){
		width = strwidth(cstr) + 8;
		/* $B$$$A$P$sC;$$9T$r$_$D$1$k(B */
		j = 0;
		for(i=1;i<MAXCANDLINES;i++){
			if(candpos[i] < candpos[j]){
				j = i;
				continue;
			}
		}
		if(candpos[j]+width > MAXCANDWIDTH) return 0;
		candkey[ncands].x = candposx + candpos[j];
		candkey[ncands].y = candposy - j * 20;
		candkey[ncands].width = width;
		candkey[ncands].height = 20;
		candkey[ncands].str = cstr;
		candkey[ncands].yomi = ystr;
		candkey[ncands].pressed = NO;
		candpos[j] += width;
		ncands++;
		if(ncands >= MAXCANDKEYS)
			return 0;
	}
	else { /* LIST */
		candposx = 5;
		candposy = 25;
		width = strwidth(cstr) + 8;
		for(i=0;i<2;i++){
			if(candpos[i] == 0 || candposx+candpos[i]+width < winwidth ){
				break;
			}
		}
		if(i >= 2) return 0;
		candkey[ncands].x = candposx + candpos[i];
		candkey[ncands].y = candposy - i * 20;
		candkey[ncands].width = width;
		candkey[ncands].height = 20;
		candkey[ncands].str = cstr;
		candkey[ncands].yomi = ystr;
		candkey[ncands].pressed = NO;
		candpos[i] += width;
		ncands++;
		if(ncands >= MAXCANDKEYS)
			return 0;
	}
	return 1;
}
