/*
	$Date: 1996/11/04 15:21:24 $
	$Revision: 1.11 $
*/
#include <stdio.h>
#include <X11/keysym.h>
#include "keys.h"

Key controlkey = {
	5, 70, 27, 20, "CTRL", "", XK_Control_L
};
Key shiftkey = {
	5, 50, 34, 20, "SHIFT", "", XK_Shift_L
};

Key cmdkey[] = { /* ASCII */
	{230, 130, 36, 20, DELSTR, "", NULL },
	{230, 90, 36, 40, ENTERSTR, "", NULL },
	{230, 70, 36, 20, MODSTR, "", NULL },
	{230, 50, 36, 20, CANSTR, "", NULL },
	{266, 130, 36, 20, DIRSTR, "", NULL },
	{266, 110, 36, 20, KANJISTR, "", NULL },
	{266, 90, 36, 20, ENGSTR, "", NULL },
	{266, 70, 36, 20, SYM1STR, "", NULL },
	{266, 50, 36, 20, SYM2STR, "", NULL },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key normal[] = {
	{5, 130, 20, 20, "`", "`", XK_quoteleft },
	{25, 130, 20, 20, "\\", "\\", XK_backslash },
	{45, 130, 20, 20, ",", ",", XK_comma },
	{65, 130, 20, 20, ".", ".", XK_period },
	{85, 130, 20, 20, "/", "/", XK_slash },
	{105, 130, 20, 20, ";", ";", XK_semicolon },
	{125, 130, 20, 20, "'", "'", XK_apostrophe },
	{145, 130, 20, 20, "[", "[", XK_bracketleft },
	{165, 130, 20, 20, "]", "]", XK_bracketright },
	{185, 130, 20, 20, "-", "-", XK_minus },
	{205, 130, 20, 20, "=", "=", XK_equal },
	{5, 110, 20, 20, "ESC", "\x1b", XK_Escape },
	{5, 90, 20, 20, "TAB", "\t", XK_Tab },
	{205, 110, 20, 20, "0", "0", XK_0 },
	{185, 110, 20, 20, "9", "9", XK_9 },
	{165, 110, 20, 20, "8", "8", XK_8 },
	{145, 110, 20, 20, "7", "7", XK_7 },
	{125, 110, 20, 20, "6", "6", XK_6 },
	{105, 110, 20, 20, "5", "5", XK_5 },
	{85, 110, 20, 20, "4", "4", XK_4 },
	{65, 110, 20, 20, "3", "3", XK_3 },
	{45, 110, 20, 20, "2", "2", XK_2 },
	{25, 110, 20, 20, "1", "1", XK_1 },
	{205, 90, 20, 20, "p", "P", XK_p },
	{185, 90, 20, 20, "o", "O", XK_o },
	{165, 90, 20, 20, "i", "I", XK_i },
	{145, 90, 20, 20, "u", "U", XK_u },
	{125, 90, 20, 20, "y", "Y", XK_y },
	{105, 90, 20, 20, "t", "T", XK_t },
	{85, 90, 20, 20, "r", "R", XK_r },
	{65, 90, 20, 20, "e", "E", XK_e },
	{45, 90, 20, 20, "w", "W", XK_w },
	{25, 90, 20, 20, "q", "Q", XK_q },
	{192, 70, 20, 20, "l", "L", XK_l },
	{172, 70, 20, 20, "k", "K", XK_k },
	{152, 70, 20, 20, "j", "J", XK_j },
	{132, 70, 20, 20, "h", "H", XK_h },
	{112, 70, 20, 20, "g", "G", XK_g },
	{92, 70, 20, 20, "f", "F", XK_f },
	{72, 70, 20, 20, "d", "D", XK_d },
	{52, 70, 20, 20, "s", "S", XK_s },
	{32, 70, 20, 20, "a", "A", XK_a },
	{159, 50, 20, 20, "m", "M", XK_m },
	{139, 50, 20, 20, "n", "N", XK_n },
	{119, 50, 20, 20, "b", "B", XK_b },
	{99, 50, 20, 20, "v", "V", XK_v },
	{79, 50, 20, 20, "c", "C", XK_c },
	{59, 50, 20, 20, "x", "X", XK_x },
	{39, 50, 20, 20, "z", "Z", XK_z },
	{179, 50, 46, 20, "SPC", " ", XK_space },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key shifted[] = {
	{5, 130, 20, 20, "~", "~", XK_grave },
	{25, 130, 20, 20, "|", "|", XK_bar },
	{45, 130, 20, 20, "<", "<", XK_less },
	{65, 130, 20, 20, ">", ">", XK_greater },
	{85, 130, 20, 20, "?", "?", XK_question },
	{105, 130, 20, 20, ":", ":", XK_colon },
	{125, 130, 20, 20, "\"", "\"", XK_quotedbl },
	{145, 130, 20, 20, "{", "{", XK_braceleft },
	{165, 130, 20, 20, "}", "}", XK_braceright },
	{185, 130, 20, 20, "_", "_", XK_underscore },
	{205, 130, 20, 20, "+", "+", XK_plus },
	{5, 110, 20, 20, "ESC", "\x1b", XK_Escape },
	{5, 90, 20, 20, "TAB", "\t", XK_Tab },
	{205, 110, 20, 20, ")", ")", XK_parenright },
	{185, 110, 20, 20, "(", "(", XK_parenleft },
	{165, 110, 20, 20, "*", "*", XK_asterisk },
	{145, 110, 20, 20, "&", "&", XK_ampersand },
	{125, 110, 20, 20, "^", "^", XK_asciicircum },
	{105, 110, 20, 20, "%", "%", XK_percent },
	{85, 110, 20, 20, "$", "$", XK_dollar },
	{65, 110, 20, 20, "#", "#", XK_numbersign },
	{45, 110, 20, 20, "@", "@", XK_at },
	{25, 110, 20, 20, "!", "!", XK_exclam },
	{205, 90, 20, 20, "P", "P", XK_P },
	{185, 90, 20, 20, "O", "O", XK_O },
	{165, 90, 20, 20, "I", "I", XK_I },
	{145, 90, 20, 20, "U", "U", XK_U },
	{125, 90, 20, 20, "Y", "Y", XK_Y },
	{105, 90, 20, 20, "T", "T", XK_T },
	{85, 90, 20, 20, "R", "R", XK_R },
	{65, 90, 20, 20, "E", "E", XK_E },
	{45, 90, 20, 20, "W", "W", XK_W },
	{25, 90, 20, 20, "Q", "Q", XK_Q },
	{192, 70, 20, 20, "L", "L", XK_L },
	{172, 70, 20, 20, "K", "K", XK_K },
	{152, 70, 20, 20, "J", "J", XK_J },
	{132, 70, 20, 20, "H", "H", XK_H },
	{112, 70, 20, 20, "G", "G", XK_G },
	{92, 70, 20, 20, "F", "F", XK_F },
	{72, 70, 20, 20, "D", "D", XK_D },
	{52, 70, 20, 20, "S", "S", XK_S },
	{32, 70, 20, 20, "A", "A", XK_A },
	{159, 50, 20, 20, "M", "M", XK_M },
	{139, 50, 20, 20, "N", "N", XK_N },
	{119, 50, 20, 20, "B", "B", XK_B },
	{99, 50, 20, 20, "V", "V", XK_V },
	{79, 50, 20, 20, "C", "C", XK_C },
	{59, 50, 20, 20, "X", "X", XK_X },
	{39, 50, 20, 20, "Z", "Z", XK_Z },
	{179, 50, 46, 20, "SPACE", " ", XK_space },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key control[] = {
	{5, 130, 20, 20, "", "", NULL },
	{25, 130, 20, 20, "^\\", "", XK_backslash },
	{45, 130, 20, 20, "", "", NULL },
	{65, 130, 20, 20, "", "", NULL },
	{85, 130, 20, 20, "", "", NULL },
	{105, 130, 20, 20, "", "", NULL },
	{125, 130, 20, 20, "", "", NULL },
	{145, 130, 20, 20, "^[", "", XK_bracketleft },
	{165, 130, 20, 20, "^]", "", XK_bracketright },
	{185, 130, 20, 20, "^_", "", XK_underscore },
	{205, 130, 20, 20, "", "", NULL },
	{5, 110, 20, 20, "ESC", "\x1b", XK_Escape },
	{5, 90, 20, 20, "TAB", "\t", XK_Tab },
	{205, 110, 20, 20, "", "", NULL },
	{185, 110, 20, 20, "", "", NULL },
	{165, 110, 20, 20, "", "", NULL },
	{145, 110, 20, 20, "", "", NULL },
	{125, 110, 20, 20, "^^", "", XK_asciicircum },
	{105, 110, 20, 20, "", "", NULL },
	{85, 110, 20, 20, "", "", NULL },
	{65, 110, 20, 20, "", "", NULL },
	{45, 110, 20, 20, "^@", "\x01", XK_at },
	{25, 110, 20, 20, "", "", NULL },
	{205, 90, 20, 20, "^P", "", XK_P },
	{185, 90, 20, 20, "^O", "", XK_O },
	{165, 90, 20, 20, "^I", "", XK_I },
	{145, 90, 20, 20, "^U", "", XK_U },
	{125, 90, 20, 20, "^Y", "", XK_Y },
	{105, 90, 20, 20, "^T", "", XK_T },
	{85, 90, 20, 20, "^R", "", XK_R },
	{65, 90, 20, 20, "^E", "", XK_E },
	{45, 90, 20, 20, "^W", "", XK_W },
	{25, 90, 20, 20, "^Q", "", XK_Q },
	{192, 70, 20, 20, "^L", "", XK_L },
	{172, 70, 20, 20, "^K", "", XK_K },
	{152, 70, 20, 20, "^J", "", XK_J },
	{132, 70, 20, 20, "^H", "", XK_H },
	{112, 70, 20, 20, "^G", "", XK_G },
	{92, 70, 20, 20, "^F", "", XK_F },
	{72, 70, 20, 20, "^D", "", XK_D },
	{52, 70, 20, 20, "^S", "", XK_S },
	{32, 70, 20, 20, "^A", "", XK_A },
	{159, 50, 20, 20, "^M", "", XK_M },
	{139, 50, 20, 20, "^N", "", XK_N },
	{119, 50, 20, 20, "^B", "", XK_B },
	{99, 50, 20, 20, "^V", "", XK_V },
	{79, 50, 20, 20, "^C", "", XK_C },
	{59, 50, 20, 20, "^X", "", XK_X },
	{39, 50, 20, 20, "^Z", "", XK_Z },
	{179, 50, 46, 20, "^@", "", XK_at },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key hiragana[] = {
	{205, 130, 20, 20, "", "", NULL },
	{185, 130, 20, 20, "", "", NULL },
	{165, 130, 20, 20, "", "", NULL },
	{145, 130, 20, 20, "", "", NULL },
	{125, 130, 20, 20, "", "", NULL },
	{105, 130, 20, 20, "", "", NULL },
	{85, 130, 20, 20, "", "", NULL },
	{65, 130, 20, 20, "", "", NULL },
	{45, 130, 20, 20, "", "", NULL },
	{25, 130, 20, 20, "", "", NULL },
	{5, 130, 20, 20, "", "", NULL },
	{205, 110, 20, 20, "", "", NULL },
	{185, 110, 20, 20, "", "", NULL },
	{165, 110, 20, 20, "", "", NULL },
	{145, 110, 20, 20, "", "", NULL },
	{125, 110, 20, 20, "", "", NULL },
	{105, 110, 20, 20, "", "", NULL },
	{85, 110, 20, 20, "", "", NULL },
	{65, 110, 20, 20, "", "", NULL },
	{45, 110, 20, 20, "", "", NULL },
	{25, 110, 20, 20, "", "", NULL },
	{5, 110, 20, 20, "", "", NULL },
	{205, 90, 20, 20, "", "", NULL },
	{185, 90, 20, 20, "", "", NULL },
	{165, 90, 20, 20, "", "", NULL },
	{145, 90, 20, 20, "", "", NULL },
	{125, 90, 20, 20, "", "", NULL },
	{105, 90, 20, 20, "", "", NULL },
	{85, 90, 20, 20, "", "", NULL },
	{65, 90, 20, 20, "", "", NULL },
	{45, 90, 20, 20, "", "", NULL },
	{25, 90, 20, 20, "", "", NULL },
	{5, 90, 20, 20, "", "", NULL },
	{205, 70, 20, 20, "", "", NULL },
	{185, 70, 20, 20, "", "", NULL },
	{165, 70, 20, 20, "", "", NULL },
	{145, 70, 20, 20, "", "", NULL },
	{125, 70, 20, 20, "", "", NULL },
	{105, 70, 20, 20, "", "", NULL },
	{85, 70, 20, 20, "", "", NULL },
	{65, 70, 20, 20, "", "", NULL },
	{45, 70, 20, 20, "", "", NULL },
	{25, 70, 20, 20, "", "", NULL },
	{5, 70, 20, 20, "", "", NULL },
	{205, 50, 20, 20, "", "", NULL },
	{185, 50, 20, 20, "", "", NULL },
	{165, 50, 20, 20, "", "", NULL },
	{145, 50, 20, 20, "", "", NULL },
	{125, 50, 20, 20, "", "", NULL },
	{105, 50, 20, 20, "", "", NULL },
	{85, 50, 20, 20, "", "", NULL },
	{65, 50, 20, 20, "", "", NULL },
	{45, 50, 20, 20, "", "", NULL },
	{25, 50, 20, 20, "", "", NULL },
	{5, 50, 20, 20, "", "", NULL },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key symbol1[] = {
	{5, 130, 20, 20, "", "", NULL },
	{25, 130, 20, 20, "", "", NULL },
	{45, 130, 20, 20, "", "", NULL },
	{65, 130, 20, 20, "", "", NULL },
	{85, 130, 20, 20, "", "", NULL },
	{105, 130, 20, 20, "", "", NULL },
	{125, 130, 20, 20, "", "", NULL },
	{145, 130, 20, 20, "", "", NULL },
	{165, 130, 20, 20, "", "", NULL },
	{185, 130, 20, 20, "", "", NULL },
	{205, 130, 20, 20, "", "", NULL },
	{5, 110, 20, 20, "", "", NULL },
	{25, 110, 20, 20, "", "", NULL },
	{45, 110, 20, 20, "", "", NULL },
	{65, 110, 20, 20, "", "", NULL },
	{85, 110, 20, 20, "", "", NULL },
	{105, 110, 20, 20, "", "", NULL },
	{125, 110, 20, 20, "", "", NULL },
	{145, 110, 20, 20, "", "", NULL },
	{165, 110, 20, 20, "", "", NULL },
	{185, 110, 20, 20, "", "", NULL },
	{205, 110, 20, 20, "", "", NULL },
	{5, 90, 20, 20, "", "", NULL },
	{25, 90, 20, 20, "", "", NULL },
	{45, 90, 20, 20, "", "", NULL },
	{65, 90, 20, 20, "", "", NULL },
	{85, 90, 20, 20, "", "", NULL },
	{105, 90, 20, 20, "", "", NULL },
	{125, 90, 20, 20, "", "", NULL },
	{145, 90, 20, 20, "", "", NULL },
	{165, 90, 20, 20, "", "", NULL },
	{185, 90, 20, 20, "", "", NULL },
	{205, 90, 20, 20, "", "", NULL },
	{5, 70, 20, 20, "", "", NULL },
	{25, 70, 20, 20, "", "", NULL },
	{45, 70, 20, 20, "", "", NULL },
	{65, 70, 20, 20, "", "", NULL },
	{85, 70, 20, 20, "", "", NULL },
	{105, 70, 20, 20, "", "", NULL },
	{125, 70, 20, 20, "", "", NULL },
	{145, 70, 20, 20, "", "", NULL },
	{165, 70, 20, 20, "", "", NULL },
	{185, 70, 20, 20, "", "", NULL },
	{205, 70, 20, 20, "", "", NULL },
	{5, 50, 20, 20, "", "", NULL },
	{25, 50, 20, 20, "", "", NULL },
	{45, 50, 20, 20, "", "", NULL },
	{65, 50, 20, 20, "", "", NULL },
	{85, 50, 20, 20, "", "", NULL },
	{105, 50, 20, 20, "", "", NULL },
	{125, 50, 20, 20, "", "", NULL },
	{145, 50, 20, 20, "", "", NULL },
	{165, 50, 20, 20, "", "", NULL },
	{185, 50, 20, 20, "", "", NULL },
	{205, 50, 20, 20, "", "", NULL },
	{5, 30, 20, 20, "", "", NULL },
	{25, 30, 20, 20, "", "", NULL },
	{45, 30, 20, 20, "", "", NULL },
	{65, 30, 20, 20, "", "", NULL },
	{85, 30, 20, 20, "", "", NULL },
	{105, 30, 20, 20, "", "", NULL },
	{125, 30, 20, 20, "", "", NULL },
	{145, 30, 20, 20, "", "", NULL },
	{165, 30, 20, 20, "", "", NULL },
	{185, 30, 20, 20, "", "", NULL },
	{205, 30, 20, 20, "", "", NULL },
	{5, 10, 20, 20, "", "", NULL },
	{25, 10, 20, 20, "", "", NULL },
	{45, 10, 20, 20, "", "", NULL },
	{65, 10, 20, 20, "", "", NULL },
	{85, 10, 20, 20, "", "", NULL },
	{105, 10, 20, 20, "", "", NULL },
	{125, 10, 20, 20, "", "", NULL },
	{145, 10, 20, 20, "", "", NULL },
	{165, 10, 20, 20, "", "", NULL },
	{185, 10, 20, 20, "", "", NULL },
	{205, 10, 20, 20, "", "", NULL },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key symbol2[] = {
	{5, 130, 20, 20, "", "", NULL },
	{25, 130, 20, 20, "", "", NULL },
	{45, 130, 20, 20, "", "", NULL },
	{65, 130, 20, 20, "", "", NULL },
	{85, 130, 20, 20, "", "", NULL },
	{105, 130, 20, 20, "", "", NULL },
	{125, 130, 20, 20, "", "", NULL },
	{145, 130, 20, 20, "", "", NULL },
	{165, 130, 20, 20, "", "", NULL },
	{185, 130, 20, 20, "", "", NULL },
	{205, 130, 20, 20, "", "", NULL },
	{5, 110, 20, 20, "", "", NULL },
	{25, 110, 20, 20, "", "", NULL },
	{45, 110, 20, 20, "", "", NULL },
	{65, 110, 20, 20, "", "", NULL },
	{85, 110, 20, 20, "", "", NULL },
	{105, 110, 20, 20, "", "", NULL },
	{125, 110, 20, 20, "", "", NULL },
	{145, 110, 20, 20, "", "", NULL },
	{165, 110, 20, 20, "", "", NULL },
	{185, 110, 20, 20, "", "", NULL },
	{205, 110, 20, 20, "", "", NULL },
	{5, 90, 20, 20, "", "", NULL },
	{25, 90, 20, 20, "", "", NULL },
	{45, 90, 20, 20, "", "", NULL },
	{65, 90, 20, 20, "", "", NULL },
	{85, 90, 20, 20, "", "", NULL },
	{105, 90, 20, 20, "", "", NULL },
	{125, 90, 20, 20, "", "", NULL },
	{145, 90, 20, 20, "", "", NULL },
	{165, 90, 20, 20, "", "", NULL },
	{185, 90, 20, 20, "", "", NULL },
	{205, 90, 20, 20, "", "", NULL },
	{5, 70, 20, 20, "", "", NULL },
	{25, 70, 20, 20, "", "", NULL },
	{45, 70, 20, 20, "", "", NULL },
	{65, 70, 20, 20, "", "", NULL },
	{85, 70, 20, 20, "", "", NULL },
	{105, 70, 20, 20, "", "", NULL },
	{125, 70, 20, 20, "", "", NULL },
	{145, 70, 20, 20, "", "", NULL },
	{165, 70, 20, 20, "", "", NULL },
	{185, 70, 20, 20, "", "", NULL },
	{205, 70, 20, 20, "", "", NULL },
	{5, 50, 20, 20, "", "", NULL },
	{25, 50, 20, 20, "", "", NULL },
	{45, 50, 20, 20, "", "", NULL },
	{65, 50, 20, 20, "", "", NULL },
	{85, 50, 20, 20, "", "", NULL },
	{105, 50, 20, 20, "", "", NULL },
	{125, 50, 20, 20, "", "", NULL },
	{145, 50, 20, 20, "", "", NULL },
	{165, 50, 20, 20, "", "", NULL },
	{185, 50, 20, 20, "", "", NULL },
	{205, 50, 20, 20, "", "", NULL },
	{5, 30, 20, 20, "", "", NULL },
	{25, 30, 20, 20, "", "", NULL },
	{45, 30, 20, 20, "", "", NULL },
	{65, 30, 20, 20, "", "", NULL },
	{85, 30, 20, 20, "", "", NULL },
	{105, 30, 20, 20, "", "", NULL },
	{125, 30, 20, 20, "", "", NULL },
	{0, 0, 0, 0, "", "", 0, 0},
};

Key *mainkey = normal;

Key *
inkey(Key *key, int x, int y)
{
	return 
		key->x < x && x <= key->x + key->width &&
		key->y < y && y <= key->y + key->height ?
		key : (Key*)NULL;
}

Key *
incmdkey(int x, int y)
{
	int i;	
	for(i=0;cmdkey[i].width;i++){
		if(inkey(&cmdkey[i],x,y)) return &cmdkey[i];
	}
	return (Key*)NULL;
}

Key *
incharkey(int x, int y)
{
	int i;	
	for(i=0;mainkey[i].width;i++){
		if(inkey(&mainkey[i],x,y)) return &mainkey[i];
	}
	return (Key*)NULL;
}

Key *
incandkey(int x, int y)
{
	int i;	
	for(i=0;i<ncands;i++){
		if(inkey(&candkey[i],x,y)) return &candkey[i];
	}
	return (Key*)NULL;
}

