/*
	$Date: 1996/11/18 15:23:04 $
	$Revision: 1.5 $
*/
#ifndef _KEYS_H_
#define _KEYS_H_

#include <X11/Xlib.h>

typedef struct {
	int x, y;
	int width, height;
	unsigned char *str;
	unsigned char *yomi;
	KeySym keysym;
	int pressed;
} Key;
/*
        mainkey    cmdkey
      
      	  
        
        
      
        candkey

	mainkeyˤASCIIܡ/Ҥ餬/ɽ
	cmdkeyˤϸ/Ԥʤɤɽ
	candkeyˤϴܥ⡼ɤǸɽ
*/
extern Key *mainkey;
extern Key cmdkey[];
extern Key candkey[];

extern Key shiftkey;
extern Key controlkey;

/* mainkey */
extern Key normal[];
extern Key shifted[];
extern Key control[];
extern Key hiragana[];
extern Key symbol1[];
extern Key symbol2[];

extern Key *inkey(Key *key, int x, int y);
extern Key *incharkey(int x, int y);
extern Key *incmdkey(int x, int y);
extern Key *incandkey(int x, int y);

#define MAXCANDKEYS 1000
extern Key keys2[];	/* ɽ */
extern int ncands;	/* ɽ */

#ifdef KANJICMDKEY
#define DELSTR ""
#define ENTERSTR ""
#define MODSTR ""
#define CANSTR ""
#define DIRSTR "ľ"
#define KANJISTR ""
#define ENGSTR "Ѹ"
#define SYM1STR ""
#define SYM2STR ""
#else
#define DELSTR "DEL"
#define ENTERSTR "RET"
#define MODSTR "MOD"
#define CANSTR "CAN"
#define DIRSTR "DIR"
#define KANJISTR ""
#define ENGSTR "ENG"
#define SYM1STR ""
#define SYM2STR ""
#endif

#endif
