/*
	$Date: 1996/11/18 15:37:24 $
	$Revision: 1.22 $
*/
#include <stdio.h>
#include <ctype.h>
#include <sys/time.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "pobox.h"
#include "keys.h"
#include "cand.h"
#include "kana.h"
#include "phrase.h"

#define YES 1
#define NO 0

Display *display;
static int screen;
Window win;
static Pixmap pix;
static GC gc;        
static XFontStruct *fk,*fa;
static Window rootwin;
static char *display_name = NULL;
static Colormap cmap;
static XColor blue, gray, darkgray, lightgray1, lightgray2;
static XSizeHints size_hints;
static unsigned long valuemask = 0;
static XGCValues values;
static XEvent report;

int winwidth = 307;
static int winheight = 155;

InputMode inputmode = ASCII;

int mvalx, mvaly;	/* ޥɸ */

int xtest = NO;

unsigned char *prevsel;

#ifdef BSD
char *dirname(char *path)
{
	static char buf[256],*s;
	if(index(path,'/')){
		strcpy(buf,path);
		if(strcmp(buf,"/")==0) return buf;
		s = buf+strlen(buf)-1;
		if(s>buf && *s == '/') s--;
		for(;s>buf+1;s--){
			if(*s == '/'){
					break;
			}
		}
		*s = '\0';
		return buf;
	}
	return ".";
}
#endif

double gettime(struct timeval *t)
{
#ifdef BSD
	struct timezone tz;
	gettimeofday(t,&tz);
#else
	gettimeofday(t);
#endif
	return (double)(t->tv_sec) + (double)(t->tv_usec)/1000000.0;
}

static int addspace = NO; /* Ѹ⡼ɤǶư뤫ɤ */

main(int argc, char **argv)
{
	int motion;
	int moved;
	Key *key;
	Key *key1 = NULL, *key2 = NULL, *key3 = NULL;
	double ellapse;
	double lastmove;
	struct timeval t;

	if(argc > 1 && strcmp(argv[1],"-x")==0) xtest = YES;
	
	chdir(dirname(argv[0]));
	readphrases();

	if((display=XOpenDisplay(display_name)) == NULL){
	        fprintf(stderr,"Can't connect to X server...");
		if(getenv("DISPLAY") == NULL)
			fprintf(stderr,", 'DISPLAY' environment variable not set.\n");
		else
			fprintf(stderr," %s\n", XDisplayName(display_name));
		exit (-1);
	}
	screen = DefaultScreen(display);
	rootwin = RootWindow(display, screen);
	win = XCreateSimpleWindow (display, rootwin, 0, 0, winwidth, winheight, 5,
		BlackPixel(display, screen), BlackPixel(display, screen));
	pix = XCreatePixmap(display, win, winwidth, winheight,
		DefaultDepth(display, screen));
	cmap=DefaultColormap(display,screen);

	XParseColor(display,cmap,"blue",&blue);
	XAllocColor(display,cmap,&blue);
	XParseColor(display,cmap,"gray60",&gray);
	XAllocColor(display,cmap,&gray);
	XParseColor(display,cmap,"gray25",&darkgray);
	XAllocColor(display,cmap,&darkgray);
	XParseColor(display,cmap,"gray75",&lightgray1);
	XAllocColor(display,cmap,&lightgray1);
	XParseColor(display,cmap,"gray90",&lightgray2);
	XAllocColor(display,cmap,&lightgray2);

	if ((fa = XLoadQueryFont(display,ASCIIFONT)) == NULL) {
		(void) fprintf(stderr,"Can't find %s...\n",ASCIIFONT);
		exit(0);
	}
	if ((fk = XLoadQueryFont(display,KANJIFONT)) == NULL) {
		(void) fprintf(stderr,"Can't find %s...\n",KANJIFONT);
		exit(0);
	}

	gc = XCreateGC(display, win, valuemask, &values);
	XSetFont(display, gc, fa->fid); 
	XSetForeground(display, gc, BlackPixel(display,screen));

	size_hints.flags = PSize | PMinSize; /* ץˤ */
	size_hints.width = winwidth;
	size_hints.height = winheight;

	XSetStandardProperties(display, win, WINDOWNAME, WINDOWNAME, None,
				0, 0, &size_hints); 

	XSelectInput(display, win, ExposureMask | ButtonPressMask |
		ButtonReleaseMask | Button1MotionMask);

	XMapWindow(display, win);

	XTestGrabControl(display,True);

	disp();

	for(;;){
		XNextEvent(display, &report);
		switch (report.type) {
		case ConfigureNotify:
			break;
		case Expose:
			disp();
			break;
		case ButtonPress:
			mvalx = report.xbutton.x;
			mvaly = winheight - report.xbutton.y;

			if(key = incmdkey(mvalx,mvaly)){
				addspace = NO;

				key->pressed = YES;
				disp();
				key->pressed = NO;

				while(1){
					XNextEvent(display, &report);
					if(report.type == ButtonRelease) break;
				}

				if(strcmp(key->str,ENTERSTR)==0){
					output("\n");
				}
				else if(strcmp(key->str,DELSTR)==0){
					int len = strlen(hstr);
					if(len > 0){
						len -= ((hstr[len-1] >= 0x80 && (len >=2)) ? 2 : 1);
						hstr[len] = '\0';
						makecand(LIST,0,0);
					}
					else {
						if(xtest)
							output("\177");
						else
							printf("<%s>\n",DELSTR);
					}
				}
				else if(strcmp(key->str,MODSTR)==0){
					if(xtest)
						output("\033xpobox-modify\n");
					else
						printf("<%s>\n",MODSTR);
				}
				else if(strcmp(key->str,CANSTR)==0 && strlen(hstr) > 0){
					strcpy(hstr,"");
					erasecand();
					makecand(LIST,0,0);
				}
				else if(strcmp(key->str,CANSTR)==0 && strlen(hstr) == 0 && xtest){
					output("\x18u"); /* control-x u */
				}
				else {
					inputmode = (strcmp(key->str,DIRSTR)==0 ? ASCII :
						     strcmp(key->str,KANJISTR)==0 ? JAPANESE :
						     strcmp(key->str,ENGSTR)==0 ? ENGLISH :
						     strcmp(key->str,SYM1STR)==0 ? SYMBOL1 :
						     strcmp(key->str,SYM2STR)==0 ? SYMBOL2 :
							inputmode);
					mainkey = (inputmode == ASCII ? normal :
						  inputmode == JAPANESE ? hiragana :
						  inputmode == ENGLISH ? normal :
						  inputmode == SYMBOL1 ? symbol1 :
						  inputmode == SYMBOL2 ? symbol2 :
						  mainkey);
					if(inputmode == ASCII || inputmode == SYMBOL1 || inputmode == SYMBOL2)
						ncands = 0;
				}
				disp();
			}
			else {
				if(inputmode == ASCII && (key = inkey(&shiftkey,mvalx,mvaly))){ /* SHIFT */
					key->pressed = ! key->pressed;
					disp();
						while(1){
						XNextEvent(display, &report);
						if(report.type == ButtonRelease) break;
					}
					mainkey = (mainkey == normal ? shifted : normal);
					if(xtest){
						XTestFakeKeyEvent(display,XKeysymToKeycode(display,key->keysym),
							key->pressed ? True : False, CurrentTime);
					}
					else {
						printf("%s\n",key->str);
					}
					disp();
				}
				else if(inputmode == ASCII && (key = inkey(&controlkey,mvalx,mvaly))){
					key->pressed = ! key->pressed;
					disp();
	
					while(1){
						XNextEvent(display, &report);
						if(report.type == ButtonRelease) break;
					}
					mainkey = (mainkey == normal ? control : normal);
					if(xtest){
						XTestFakeKeyEvent(display,XKeysymToKeycode(display,key->keysym),
							key->pressed ? True : False, CurrentTime);
					}
					else {
						printf("%s\n",key->str);
					}
					disp();
				}
				else if((inputmode == ASCII || inputmode == SYMBOL1 || inputmode == SYMBOL2) &&
				     (key = incharkey(mvalx,mvaly))){
					key->pressed = YES;
					disp();
					key->pressed = NO;
	
					while(1){
						XNextEvent(display, &report);
						if(report.type == ButtonRelease) break;
					}
/* sleep(2); */
					if(xtest){
						if(inputmode == ASCII){
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,key->keysym),True,CurrentTime);
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,key->keysym),False,CurrentTime);
						}
						else
							output(key->str);
					}
					else {
						printf("%s\n",key->str);
					}
					if(shiftkey.pressed){
						if(xtest)
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,shiftkey.keysym),False,CurrentTime);
						shiftkey.pressed = NO;
						mainkey = normal;
					}
					if(controlkey.pressed){
						if(xtest)
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,controlkey.keysym),False,CurrentTime);
						controlkey.pressed = NO;
						mainkey = normal;
					}
					disp();
				}
				else if((inputmode == JAPANESE || inputmode == ENGLISH) && 
				     (key1 = incharkey(mvalx,mvaly))){ /* ͽ¬Ѥ⡼ */
					unsigned char buf[1000];
					unsigned char newhstr[1000];

					if(punctuation(key1->yomi)){
						key1->pressed = YES;
						disp();
						key1->pressed = NO;
						while(1){
							XNextEvent(display, &report);
							if(report.type == ButtonRelease) break;
						}
						/* erasecand(); */
						output(key1->yomi);
						disp();

						addspace = (strcmp(key1->str,",")==0 || strcmp(key1->str,".")==0);
					}
					else {
						strcat(hstr,lowercase(key1->yomi));
						fflush(stdout);
		
						key1->pressed = YES;
	
						disp();
						key1->pressed = NO;
		
						lastmove = gettime(&t);
						lastmove -= 0.1;
		
						key2 = key1;
		
						strcpy(buf,hstr);
	
						moved = YES;
						motion = NO;
						while(1){
							if(XEventsQueued(display,QueuedAfterFlush) > 0){
								XNextEvent(display, &report);
								if(report.type == ButtonRelease) break;
								if(report.type == MotionNotify){
									mvalx = report.xmotion.x;
									mvaly = winheight - report.xmotion.y;
									motion = YES;
								}
								if(XEventsQueued(display,QueuedAfterFlush) > 0) /* ޤä٥Ȥƽ */
									continue;
							}
							if(key3 = incandkey(mvalx,mvaly)){
								if(key3 != key2){
									key3->pressed = YES;
									disp();
									key3->pressed = NO;
									key2 = key3;
								}
							}
							else if(key3 = incharkey(mvalx,mvaly)){
								if(key3 != key2){ /* ֤ذư */
									lastmove = gettime(&t);
									moved = YES;
		
									key3->pressed = YES;
									erasecand();
									disp();
									key3->pressed = NO;
		
									key2 = key3;
									strcpy(buf,hstr);
								}
								else {	/* Ʊ */
									ellapse = gettime(&t) - lastmove;
									if(moved && ellapse > 0.4){ /* 0.4ƱȤ */
										moved = NO;
										strcpy(hstr,buf);
										if(key2 != key1){
											strcat(hstr,lowercase(key2->str));
											key1 = NULL;
										}
										key2->pressed = YES;
										makecand(MENU,
											mvalx-10 > winwidth-MAXCANDWIDTH ? winwidth-MAXCANDWIDTH : mvalx-10,
											mvaly-21);
										disp();
										key2->pressed = NO;
									}
								}
							}
						}
/* sleep(2); */
						if(key2 = incandkey(mvalx,mvaly)){
							unsigned char *h;
							h = lowercase(ztoh(key2->str));
							strcat(outstr,h);
							if(inputmode == ENGLISH && addspace)
								output(" ");
							output(h);
							addspace = havealpha(h);
							strcpy(hstr,"");
							if(inputmode == JAPANESE){
								if(strncmp(key2->str,"",2) && strncmp(key2->str,"",2)){
									prevsel = addphrase(prevsel,key2->str,key2->yomi);
									makecand(LIST,0,0);
								}
								else {
									erasecand();
								}
							}
							else if(inputmode == ENGLISH){
								if(isalpha(*(key2->str))){
									prevsel = addphrase(prevsel,key2->str,key2->yomi);
									makecand(LIST,0,0);
								}
								else {
									erasecand();
								}
							}
						}
						else if(key2 = incharkey(mvalx,mvaly)){
	/*						erasecand(); */
							makecand(LIST,0,0);
						}
						disp();
					}
				}
				else if((inputmode == JAPANESE || inputmode == ENGLISH) && 
				     (key1 = incandkey(mvalx,mvaly))){ /* ͽ¬Ѥ⡼ */
					fflush(stdout);
					key1->pressed = YES;
					disp();
					key1->pressed = NO;
					motion = NO;
					while(1){
						XNextEvent(display, &report);
						if(report.type == ButtonRelease) break;
						if(report.type == MotionNotify){
							mvalx = report.xmotion.x;
							mvaly = winheight - report.xmotion.y;
							motion = YES;
						}
						if(XEventsQueued(display,QueuedAfterFlush) > 0) /* ޤä٥Ȥƽ */
							continue;
						if(! motion)
							continue;
						motion = NO;
						key2 = incandkey(mvalx,mvaly);
						if(key2 != key1){
							if(key2){
								key2->pressed = YES;
							}
							disp();
							if(key2){
								key2->pressed = NO;
							}
						}
						key1 = key2;
					}
/* sleep(2); */ 
					if(key1){
						strcat(outstr,key1->str);
						if(inputmode == ENGLISH && addspace)
							output(" ");
						output(key1->str);
						addspace = havealpha(key1->str);
						strcpy(hstr,"");
						prevsel = addphrase(prevsel,key1->str,key1->yomi);
						makecand(LIST,0,0);
						disp();
					}
				}
			}
		}
/*		XFlush(display); */
	}
}

disp()
{
	int i;
	Key *keyp;

	XSetForeground(display, gc, gray.pixel);
	XFillRectangle(display,pix,gc,0,0,winwidth,winheight);

	if(inputmode==ASCII){
		dispkey(&shiftkey);
		dispkey(&controlkey);
	}

	for(keyp = mainkey; keyp->width > 0; keyp++){
		dispkey(keyp);
	}
	for(keyp = cmdkey; keyp->width > 0; keyp++){
		dispkey(keyp);
	}
	for(i=ncands-1;i>=0;i--){
		dispkey(&candkey[i]);
	}

	XCopyArea(display, pix, win, gc, 0, 0, winwidth, winheight, 0, 0);
	XFlush(display);
}

dispkey(Key *key)
{
	if(key->pressed){
		buttonx(key->x,key->y,key->x+key->width-1,key->y+key->height);
	}
	else {
		button(key->x,key->y,key->x+key->width-1,key->y+key->height);
	}
	XSetForeground(display, gc, BlackPixel(display,screen));
	prstr(key->str, key->x + (key->width - strwidth(key->str))/2 - 1,
		key->height <= 20 ? key->y+5 : key->y+10);
}

line(int x1, int y1, int x2, int y2)
{
	XDrawLine(display, pix, gc, x1, winheight-y1-1, x2, winheight-y2-1);
}
fillrect(int x1, int y1, int x2, int y2)
{
	XFillRectangle(display,pix,gc,x1,winheight-y2-1,x2-x1+1,y2-y1+1);
}

button(int x1, int y1, int x2, int y2)
{
	XSetForeground(display, gc, lightgray1.pixel);
	fillrect(x1,y1,x2,y2);
	XSetForeground(display, gc, lightgray2.pixel);
	line(x1,y1,x1,y2);		line(x1,y2,x2,y2);
	line(x1+1,y1+1,x1+1,y2-1);	line(x1+1,y2-1,x2-1,y2-1);
	XSetForeground(display, gc, darkgray.pixel);
	line(x2,y1,x2,y2);		line(x1,y1,x2,y1);
	line(x2-1,y1+1,x2-1,y2-1);	line(x1+1,y1+1,x2-1,y1+1);
}
buttonx(int x1, int y1, int x2, int y2)
{
	XSetForeground(display, gc, lightgray2.pixel);
	fillrect(x1,y1,x2,y2);
	XSetForeground(display, gc, darkgray.pixel);
	line(x1,y1,x1,y2);		line(x1,y2,x2,y2);
	line(x1+1,y1+1,x1+1,y2-1);	line(x1+1,y2-1,x2-1,y2-1);
	XSetForeground(display, gc, lightgray1.pixel);
	line(x2,y1,x2,y2);		line(x1,y1,x2,y1);
	line(x2-1,y1+1,x2-1,y2-1);	line(x1+1,y1+1,x2-1,y1+1);
}

prstr(unsigned char *s, int x, int y)
{
	int i = 0;
	enum { E, J , N } ej = N;
	char buf[1000];
	XChar2b buf2[1000];

	while(*s){
		if(*s < 0x80){
			if(ej == J){
				XSetFont(display, gc, fk->fid); 
				XDrawString16(display, pix, gc, x, winheight-y-1, buf2, i);
				x += XTextWidth16(fk, buf2, i);
				i = 0;
			}
			ej = E;
			buf[i++] = *s++;
		}
		else {
			if(ej == E){
				XSetFont(display, gc, fa->fid); 
				XDrawString(display, pix, gc, x, winheight-y-1, buf, i);
				x += XTextWidth(fa, buf, i);
				i = 0;
			}
			ej = J;
			buf2[i].byte1 = (*s & 0x7f);
			buf2[i].byte2 = (*(s+1) & 0x7f);
			i++;
			s+=2;
		}
	}
	if(ej == J && i > 0){
		XSetFont(display, gc, fk->fid); 
		XDrawString16(display, pix, gc, x, winheight-y-1, buf2, i);
	}
	else if(ej == E && i > 0){
		XSetFont(display, gc, fa->fid); 
		XDrawString(display, pix, gc, x, winheight-y-1, buf, i);
	}
}

strwidth(unsigned char *str)
{
	int i, width;
	unsigned char *s = str;
	enum { E, J , N } ej = N;
	char buf[1000];
	XChar2b buf2[1000];

	i = width = 0;
	while(*s){
		if(*s < 0x80){
			if(ej == J){
				XSetFont(display, gc, fk->fid); 
				width += XTextWidth16(fk, buf2, i);
				i = 0;
			}
			ej = E;
			buf[i++] = *s++;
		}
		else {
			if(ej == E){
				XSetFont(display, gc, fa->fid); 
				width += XTextWidth(fa, buf, i);
				i = 0;
			}
			ej = J;
			buf2[i].byte1 = (*s & 0x7f);
			buf2[i].byte2 = (*(s+1) & 0x7f);
			i++;
			s+=2;
		}
	}
	if(ej == J && i > 0){
		XSetFont(display, gc, fk->fid); 
		width += XTextWidth16(fk, buf2, i);
	}
	else if(ej == E && i > 0){
		XSetFont(display, gc, fa->fid); 
		width += XTextWidth(fa, buf, i);
	}
	return width;
}

static unsigned char *punctstr[] = {
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	".",
	",",
	NULL
};

punctuation(unsigned char *s)
{
	int i;
	unsigned char *p;
	if(*s < 0x80 && !isalpha(*s))
		return 1;
	for(i=0;p = punctstr[i]; i++){
		if(strcmp(s,p)==0) return 1;
	}
	return 0;
}

#define JISIN "\033$B"
#define JISOUT "\033(B"

unsigned char *
ujis2jis(unsigned char *ujis){
	static unsigned char jis[10000];
	unsigned char *s = jis;
	enum { E, J } mode = E;

	while(*ujis){
		if(*ujis < 0x80){
			if(mode == J){
				sprintf(s,"%s",JISOUT);
				s += 3;
				mode = E;
			}
			*s++ = *ujis++;
		}
		else {
			if(mode == E){
				sprintf(s,"%s",JISIN);
				s += 3;
				mode = J;
			}
			*s++ = *ujis++ & 0x7f;
			*s++ = *ujis++ & 0x7f;
		}
	}
	if(mode == J){
		sprintf(s,"%s",JISOUT);
		s += 3;
	}
	*s = '\0';
	return jis;
}

havealpha(unsigned char *s)
{
	for(;*s;s++){
		if(isalpha(*s)) return 1;
	}
	return 0;
}

output(unsigned char *s)
{
	KeySym keysym;
	Key *keyp;
	char buf[2];

	buf[1] = '\0';

	if(xtest){
		s = ujis2jis(s);
		for(;*s;s++){
			buf[0] = *s;
			if(*s == '\n'){
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Return),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Return),False,CurrentTime);
			}
			else if(*s == ' '){
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_space),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_space),False,CurrentTime);
			}
			else if(*s == '\033'){
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Escape),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Escape),False,CurrentTime);
			}
			else if(*s == '\177'){
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Delete),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Delete),False,CurrentTime);
			}
			else if(*s == '\x18'){ /* control-X */
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Control_L),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_x),True,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_x),False,CurrentTime);
				XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Control_L),False,CurrentTime);
			}
			else {
				for(keyp = normal; keyp->width > 0; keyp++){
					if(strcmp(buf,keyp->str)==0){
						XTestFakeKeyEvent(display,XKeysymToKeycode(display,keyp->keysym),True,CurrentTime);
						XTestFakeKeyEvent(display,XKeysymToKeycode(display,keyp->keysym),False,CurrentTime);
						break;
					}
				}
				if(keyp->width == 0){
					for(keyp = shifted; keyp->width > 0; keyp++){
						if(strcmp(buf,keyp->str)==0){
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Shift_L),True,CurrentTime);
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,keyp->keysym),True,CurrentTime);
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,keyp->keysym),False,CurrentTime);
							XTestFakeKeyEvent(display,XKeysymToKeycode(display,XK_Shift_L),False,CurrentTime);
							break;
						}
					}
				}
			}
		}
	}
	else {
		printf("<%s>\n",s);
	}
}
